//////////////////////////////////////////////////////////////////////////////

#include "linkio.cpp"

//////////////////////////////////////////////////////////////////////////////
// Terminal -                                                               //
//////////////////////////////////////////////////////////////////////////////

void Terminal()
{
  clrscr();
  while (1) {
    char c;
    if (!kbhit())
      c = Transfer(0);
    else {
      c = getch();
      switch (c) {
	case 27: return;
	default: c = Transfer(c);
      }
    }
    if (c) printf("%c", c);
    if (c==10) printf("\n");
  }
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

int TestTitle()
{
  char data[16];
  if (Read(data, 0x134, 16)) return 0;
  printf("Title: %s\n", data);
  return 0;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void SetColor(int r, int g, int b)
{
  unsigned p = (r) | (g)<<5 | (b)<<10;
  WriteByte(0xFF69, p);
  WriteByte(0xFF69, p>>8);
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void SetPalette(int r, int g, int b)
{
  SetColor(r,g,b);
  SetColor(r/2,g/2,b/2);
  SetColor(r/4,g/4,b/4);
  SetColor(0,0,0);
}

//////////////////////////////////////////////////////////////////////////////
// main - Main program                                                      //
//////////////////////////////////////////////////////////////////////////////

int main()
{
  ReturnOnError(Init());
  WriteByte(0xFF40, 0);
  WriteByte(0xFF68, 128);
  SetPalette(31,0,0);
  SetPalette(0,31,0);
  SetPalette(0,0,31);
  SetPalette(31,31,0);
  SetPalette(0,31,31);
  SetPalette(31,0,31);
  SetPalette(15,15,15);
  SetPalette(31,31,31);
  WriteByte(0xFF40, 0x81);
  return 0;
}

//////////////////////////////////////////////////////////////////////////////